;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SCRIPT85.ASM : Script85 1.1
;; Script85 allows you to write full-sized text to the graph screen.
;; Copyright 1997 Rob Linwood / Aunt Floyd Productions
;; Feel free to use any part of this for whatever reasons. If you see anything
;; that could be improved, mail me at rob.linwood@k-palace.com
;;
;; Theory of operation:
;;     You write text onto the video screen. When the user finishes typing,
;;     the contents of the VIDEO_MEM are copied en masse into GRAPH_MEM.
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#include "ti-85.h"                 ; include the file "ti-85.h"
.org 0                             ; tells TASM to start code
.db "Script85 1.1 by Rob",0        ; title in ZShell



       set 3,(IY+05)               ; White-on-black text


;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
InitScreen:                        ; This block of code draws the main menu
       ROM_CALL(CLEARLCD)          ; clear the lcd
       ld a,0                      ; 0 -> A
       ld (CURSOR_COL),a           ; sets the text cursor column to 0
       ld (CURSOR_ROW),a           ; sets the text cursor row to 0
       ld de,(PROGRAM_ADDR)        ; loads program address into DE
       ld hl,title1                ; loads address of title1 into HL
       add hl,de                   ; DE + HL -> HL
       ROM_CALL(D_ZT_STR)          ; displays string pointed to by HL (title1)
       ld a,4                      ; 4 -> A
       ld (CURSOR_ROW),a           ; sets text cursor row to 4
       ld de,(PROGRAM_ADDR)        ; loads program address into DE
       ld hl,option1               ; loads address of option1 into HL
       add hl,de                   ; DE + HL -> HL
       ROM_CALL(D_ZT_STR)          ; Displays data pointed to by HL (option1)
       res 3,(IY+05)               ; Black on white text
       ld de,(PROGRAM_ADDR)        ; loads program address into DE
       ld hl,option2               ; points HL to option2
       add hl,de                   ; DE + HL -> HL
       ROM_CALL(D_ZT_STR)          ; displays data pointed to by HL (option2)
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
                                   ;
Wait4Fkeys:                        ; This code waits for an Function key to
       CALL_(Wait4Key)             ; be pressed
       cp K_F1                     ; compares A with F1 key's value
       JUMP_Z(WonB)                ; if zero flag is set, jump to WonB
       cp K_F2                     ;
       JUMP_Z(BonW)                ; Same as above, only different values
       cp K_EXIT                   ;
       JUMP_Z(EndOfS85)            ;
       jr Wait4Fkeys               ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-                                   
                                   ;
Loop2:                             ; This sets initial screen for writing
       ROM_CALL(CLEARLCD)          ; like CLS
       ld a,0                      ; 0 -> A
       ld (CURSOR_COL),a           ; sets A (0) as text cursor column
       ld (CURSOR_ROW),a           ; sets A (0) as text cursor row
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
                                   ; This block of code takes in keyboard   
InputLoop:                         ; scan codes and compares to the keycodes
       CALL_(Wait4Key)             ; for various letters. To see which codes
       cp K_MORE                   ; (the 'K_xxx' things) go with what keys,
       JUMP_Z(TextMovement)        ; look at ti-85.h (or don't. they're all
       cp K_LOG                    ; fairly obvious)
       JUMP_Z(hitA)                ;
       cp K_SIN                    ;
       JUMP_Z(hitB)                ;
       cp K_COS                    ;
       JUMP_Z(hitC)                ;
       cp K_TAN                    ;
       JUMP_Z(hitD)                ;
       cp K_RAISE                  ;
       JUMP_Z(hitE)                ;
       cp K_LN                     ;
       JUMP_Z(hitF)                ;
       cp K_EE                     ;
       JUMP_Z(hitG)                ;
       cp K_LEFTPAR                ;
       JUMP_Z(hitH)                ;
       cp K_RIGHTPAR               ;
       JUMP_Z(hitI)                ;
       cp K_SLASH                  ;
       JUMP_Z(hitJ)                ;
       cp K_SQUARE                 ;
       JUMP_Z(hitK)                ;
       cp K_7                      ;
       JUMP_Z(hitL)                ;
       cp K_8                      ;
       JUMP_Z(hitM)                ;
       cp K_9                      ;
       JUMP_Z(hitN)                ;
       cp K_STAR                   ;
       JUMP_Z(hitO)                ;
       cp K_COMMA                  ;
       JUMP_Z(hitP)                ;
       cp K_4                      ;
       JUMP_Z(hitQ)                ;
       cp K_5                      ;
       JUMP_Z(hitR)                ;
       cp K_6                      ;
       JUMP_Z(hitS)                ;
       cp K_MINUS                  ;
       JUMP_Z(hitT)                ;
       cp K_STO                    ;
       JUMP_Z(hitEq)               ;
       cp K_1                      ;
       JUMP_Z(hitU)                ;
       cp K_2                      ;
       JUMP_Z(hitV)                ;
       cp K_3                      ;
       JUMP_Z(hitW)                ;
       cp K_PLUS                   ;
       JUMP_Z(hitX)                ;
       cp K_0                      ;
       JUMP_Z(hitY)                ;
       cp K_DOT                    ;
       JUMP_Z(hitZ)                ;
       cp K_SIGN                   ;
       JUMP_Z(hitSpace)            ;
       cp K_F1                     ;
       JUMP_Z(hitPeriod)           ;
       cp K_F2                     ;
       JUMP_Z(hitComma)            ;
       cp K_F3                     ;
       JUMP_Z(hitColon)            ;
       cp K_ENTER                  ;
       JUMP_Z(hitEnter)            ;
       cp K_F4                     ;
       JUMP_Z(hitSemi)             ;
       cp K_F5                     ;
       JUMP_Z(hitBang)             ;
       cp K_SECOND                 ;
       JUMP_Z(hitMinus)            ;
       cp K_ALPHA                  ;
       JUMP_Z(hitPlus)             ;
       cp K_GRAPH                  ;
       JUMP_Z(hitMult)             ;
       cp K_XVAR                   ;
       JUMP_Z(hitBSlash)           ;
       cp K_STAT                   ;
       JUMP_Z(hitFSlash)           ;
       cp K_DEL                    ;
       JUMP_Z(hitDel)              ;
       cp K_EXIT                   ;
       JUMP_Z(EndOfS85)           ;
       cp K_CLEAR                  ;
       JUMP_Z(hitClear)            ;
       cp K_UP                     ;
       JUMP_Z(hitUp)               ;
       cp K_DOWN                   ;
       JUMP_Z(hitDown)             ;
       JUMP_(InputLoop)            ;
                                   ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
                                   ; These labels are JUMPed to when the
hitA:                              ; comparisons in the above chunk equal
       ld a,'A'                    ; zero.
       JUMP_(ReturnL)              ;
                                   ; All the labels have the the same pattern
hitB:                              ; of code after them:
       ld a,'B'                    ;                           
       JUMP_(ReturnL)              ;      ld a, 'x'             
                                   ;      JUMP_(ReturnL)
hitC:                              ;
       ld a,'C'                    ; The 'x' character is the character that
       JUMP_(ReturnL)              ; will be displayed. 
                                   ; 'JUMP_(ReturnL)' jumps to the RetrunL
hitD:                              ; label
       ld a,'D'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitE:                              ;
       ld a,'E'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitF:                              ;
       ld a,'F'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitG:                              ;
       ld a,'G'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitH:                              ;
       ld a,'H'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitI:                              ;
       ld a,'I'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitJ:                              ;
       ld a,'J'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitK:                              ;
       ld a,'K'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitL:                              ;
       ld a,'L'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitM:                              ;
       ld a,'M'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitN:                              ;
       ld a,'N'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitO:                              ;
       ld a,'O'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitP:                              ;
       ld a,'P'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitQ:                              ;
       ld a,'Q'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitR:                              ;
       ld a,'R'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitS:                              ;
       ld a,'S'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitT:                              ;
       ld a,'T'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitU:                              ;
       ld a,'U'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitV:                              ;
       ld a,'V'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitW:                              ;
       ld a,'W'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitX:                              ;
       ld a,'X'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitY:                              ;
       ld a,'Y'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitZ:                              ;
       ld a,'Z'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitComma                           ;
       ld a,','                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitPeriod:                         ;
       ld a,'.'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitColon:                          ;
       ld a,':'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitSpace:                          ;
       ld a,' '                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitEq:                             ;
       ld a,'='                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitSemi:                           ;
       ld a,$3B                    ; This is done because we can't do 
       JUMP_(ReturnL)              ; "ld a, ';'" because anything after a 
                                   ; semicolon is considered a comment, and 
hitBang:                           ; TASM won't compile it
       ld a,'!'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitMinus:                          ;
       ld a,'-'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitPlus                            ;
       ld a,'+'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitFSlash                          ;
       ld a,$5C                    ; This is done because a \ in TASM denotes
       JUMP_(ReturnL)              ; another statement. 5C = ASCII value of /
                                   ;
hitBSlash                          ;
       ld a,'/'                    ;
       JUMP_(ReturnL)              ;
                                   ;
hitMult:                           ;
       ld a,'*'                    ;
       JUMP_(ReturnL)              ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
                                   ; This chunk of code is jumped to when
hitEnter:                          ; enter is hit. It does a CR/LF thing.
       ld a,(CURSOR_ROW)           ; loads the current cursor row into A
       cp 7                        ; compares A to 7 (really A-7)
       JUMP_Z(Up_Row)              ; if result is 0, jump to Up_Row
       inc a                       ; increase A by one
       ld (CURSOR_ROW),a           ; loads A into the cursor row
       ld a,0                      ; 0 -> A
       ld (CURSOR_COL),a           ; loads A into cursor column
       JUMP_(InputLoop)            ; jumps to InputLoop
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
                                   ; These routines delete the last character.
hitDel:                            ; If the CURSOR_COL=0, then DelBack is 
       ld a,(CURSOR_COL)           ; jumped to.
       cp 0                        ;
       JUMP_Z(DelBack)             ;
       dec a                       ;
       ld (CURSOR_COL),a           ;
       ld a,' '                    ;
       ROM_CALL(TX_CHARPUT)        ;
       ld a,(CURSOR_COL)           ;
       dec a                       ;
       ld (CURSOR_COL),a           ;
       JUMP_(InputLoop)            ;
                                   ;
DelBack:                           ;
       ld a,20                     ;
       ld (CURSOR_COL),a           ;
       ld a,(CURSOR_ROW)           ;
       dec a                       ;
       ld (CURSOR_ROW),a           ;
       ld a,' '                    ;
       ROM_CALL(TX_CHARPUT)        ;
       ld a,20                     ;
       ld (CURSOR_COL),a           ;
       ld a,(CURSOR_ROW)           ;
       dec a                       ;
       ld (CURSOR_ROW),a           ;
       JUMP_(InputLoop)            ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
                                   ; This label is jumped to when [CLEAR] is
hitClear:                          ; hit. It clears the screen, and restores
       ROM_CALL(CLEARLCD)          ; the cursor postion to the upper-left
       ld a,0                      ; corner.
       ld (CURSOR_COL),a           ;
       ld (CURSOR_ROW),a           ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

hitUp:                             ;
       res 3,(IY+05)               ; sets text to be black-on-white       
       JUMP_(InputLoop)            ;
                                   ;
hitDown:                           ;
       set 3,(IY+05)               ; sets text to white-on-black
       JUMP_(InputLoop)            ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
                                   ; All this does is call SCROLL_UP, which
Up_Row:                            ; scrolls the screen up one line. It then
       ROM_CALL(SCROLL_UP)         ; sets the cursor column to 0
       ld a,0                      ;
       ld a,(CURSOR_COL)           ;
       JUMP_(InputLoop)            ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
                                   ; This is jumped to by all the hitx things
ReturnL:                           ; it puts the character stored in A on the
       ROM_CALL(TX_CHARPUT)        ; screen at the current cursor row & column
       JUMP_(InputLoop)            ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
                                   ; These labels are jumped to when you hit
WonB:                              ; F1 or F2 at the main menu.
       set 3,(IY+05)               ; sets text to be white-on-black
       JUMP_(Loop2)                ;
                                   ;
BonW:                              ;
       res 3,(IY+05)               ; sets text to be black-on-white
       JUMP_(Loop2)                ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- 
                                   ; This allows you to move the screen up
TextMovement:                      ; after you hit EXIT. If you don't hit
       CALL_(Wait4Key)             ; the up arrow, you get jumped to 
       cp K_UP                     ; CopyToGraph.
       JUMP_Z(ScrollUp)            ;
       JUMP_(CopyToGraph)          ;
                                   ;
ScrollUp:                          ; This moves the screen up one line, and 
       ROM_CALL(SCROLL_UP)         ; jumps to TextMovement.
       jr TextMovement             ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- 
                                   ;
CopyToGraph:                       ; This routine copies the contents of the
                                   ; home screen to the graph. This is VERY 
        ld hl,$FC00                ; useful for screen-capturing.
        ld de,GRAPH_MEM            ;
        ld bc,1024                 ;
        ldir                       ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- 
EndOfS85:                          ;
       res 3,(IY+05)               ;
       ROM_CALL(CLEARLCD)          ;
       ld a,0                      ;
       ld (CURSOR_COL),a           ;
       ld (CURSOR_ROW),a           ;
       ld a,$F                     ;
       ld (CURSOR_X),a             ;
       ld a,$19                    ;
       ld (CURSOR_Y),a             ;
       ld de,(PROGRAM_ADDR)        ; This routine displays the info at the
       ld hl,info2                 ; end of the program.
       add hl,de                   ;
       ROM_CALL(D_ZM_STR)          ;
       ld a,$C                     ;
       ld (CURSOR_X),a             ;
       ld a,$23                    ;
       ld (CURSOR_Y),a             ;
       ld de,(PROGRAM_ADDR)        ;
       ld hl,info3                 ;
       add hl,de                   ;
       ROM_CALL(D_ZM_STR)          ;
       ld de,(PROGRAM_ADDR)        ;
       ld hl,info1                 ;
       add hl,de                   ;
       ROM_CALL(D_ZT_STR)          ;
       CALL_(Wait4Key)             ;
       ret                         ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-                                    ;
                                   ; This routine waits for a key to be 
Wait4Key:                          ; pressed by CALLing GET_KEY until the 
       CALL GET_KEY                ; scancode <> 0 (ie, there was a key hit)
       cp 0                        ;
       JUMP_Z(Wait4Key)            ;
       ret                         ;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- 
; This section is just string definitions which are pointed to by HL.
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- 

title1:
       .db "Script85 Version 1.1 "
       .db "   by Rob Linwood    "
       .db "   Copyright 1997    ",0

option1:
       .db "F1: White on black   ",0

option2
       .db "F2: Black on white",0

info1:
       .db "Please send comments,"
       .db "suggestions, flames &"
       .db "anything else to:",0
       
info2:
       .db "rob.linwood@k-palace.com",0

info3:
       .db "http://robwww.home.ml.org/",0

       
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
                                   ; This signals the end!
.end                               ;

